/*
 * File:   newmain.c
 * Author: Ing. Jaroslav Ollah
*/

#pragma config FOSC = INTRC_NOCLKOUT
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled and can be enabled by SWDTEN bit of the WDTCON register)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = ON       // RE3/MCLR pin function select bit (RE3/MCLR pin function is MCLR)
#pragma config CP = OFF         // Code Protection bit (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Code Protection bit (Data memory code protection is disabled)
#pragma config BOREN = OFF      // Brown Out Reset Selection bits (BOR disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enabled bit (Fail-Safe Clock Monitor is disabled)
#pragma config LVP = OFF
#pragma config BOR4V = BOR40V   // Brown-out Reset Selection bit (Brown-out Reset set to 4.0V)
#pragma config WRT = OFF




#include <xc.h>
#include <stdio.h>
#include <stdint.h>
#include <math.h>
#include "usart.h"

#define  _XTAL_FREQ 4000000UL


#define tlac1 PORTDbits.RD3
#define tlac2 PORTDbits.RD0
#define tlac3 PORTBbits.RB4
#define tlac4 PORTAbits.RA7
#define led   PORTAbits.RA6


uint8_t tlac1_zakmit(void)
{
    uint8_t a,b;
    do
    {
        a=tlac1;
        __delay_ms(10);
        b=tlac1;
    }
    while(a!=b);
    return a;
}
uint8_t tlac2_zakmit(void)
{
    uint8_t a,b;
    do
    {
        a=tlac2;
        __delay_ms(10);
        b=tlac2;
    }
    while(a!=b);
    return a;
}
uint8_t tlac3_zakmit(void)
{
    uint8_t a,b;
    do
    {
        a=tlac3;
        __delay_ms(10);
        b=tlac3;
    }
    while(a!=b);
    return a;
}
uint8_t tlac4_zakmit(void)
{
    uint8_t a,b;
    do
    {
        a=tlac4;
        __delay_ms(10);
        b=tlac4;
    }
    while(a!=b);
    return a;
}






void main(void)
{
    
     TRISD=0b00001001;
     TRISA=0b10000000;
     TRISE=0b00000000;
     TRISC=0b00000000;
     TRISB=0b00010000;
     
     
     PORTA=0b00000000;
     PORTB=0b00000000;
     PORTC=0b00000000;
     PORTD=0b00000000;
     
     ADCON1=0;
     ANSEL=0;
     ADCON0=0;
     ANSELH=0;
    
         
     USARTinit ();
     led=1;
     while(1)
     {               
       tlac1_zakmit();
       if(tlac1==1)
       {          
           uartPrint("A");
           __delay_ms(100);
       }
         
       
        tlac2_zakmit();
       if(tlac2==1)
       {          
           uartPrint("B");
           __delay_ms(100);
       }
        
        
       tlac3_zakmit();
       if(tlac3==1)
       {          
           uartPrint("C");
           __delay_ms(100);
       }        
       
       
       tlac4_zakmit();
       if(tlac4==1)
       {          
           uartPrint("D");
           __delay_ms(100);
       }
       
       
       if(PIR1bits.RCIF)
      {
        int c = UART_GetC();
        
        if(c==0x02)
        {
            led=0;
        }else{led=1;}
      }             
     }         
    return;
}
